import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.text.*;

public class SaveXml implements DocumentBaliseName
{
public static void WriteTagAttribut(PrintWriter _writer,Tag.AttributValue _val)
{
_writer.print("<"+attribut_def+" "+attribut_name+"=\""+_val.getName()+"\" "+attribut_value+"=\""+_val.getValue()+"\" />\n");
}
public static void WriteAttributListe(PrintWriter _writer ,Tag v)
{
_writer.print("<"+attribut_liste+">\n");
for (int i=0;i<v.nbAttribut();i++)
{
WriteTagAttribut(_writer,v.get(i));
}
_writer.print("</"+attribut_liste+">\n");
}
public static void WriteTag(PrintWriter _writer,Tag t)
{
_writer.print("<"+tag_def+" "+nb_balise+"=\""+t.getBalise().getOrder()+"\" "+debut+"=\""+t.getDebut()+"\"");
_writer.print(" "+fin+"=\""+t.getFin()+"\" "+isdead+"=\""+t.IsDead()+"\" "+ligne+"=\""+t.getLigne()+"\" >\n");
WriteAttributListe(_writer,t);
_writer.print("</"+tag_def+">\n");

}
public static void WriteListeTag(PrintWriter _writer,ListeTag t)
{
_writer.print("<"+liste_tag+">\n");
for (int i=0;i<t.size();i++) WriteTag(_writer,t.get(i));
_writer.print("</"+liste_tag+">\n");
}
public static void WriteAttributDecl(PrintWriter _writer,AttributDecl _decl)
{
_writer.print("<"+attribut_balise_def+" "+attribut_balise_name+"=\""+_decl.getName()+"\" "+attribut_balise_type+"=\"");
_writer.print(_decl.getType()+"\" "+attribut_balise_default+"=\""+_decl.getValueDefault()+"\"");
_writer.print(" "+attribut_balise_valeur+"=\""+_decl.getValue()+"\" "+attribut_enum+"=\""+_decl.getEnum()+"\"");
/*if (_decl.getEnum())
{*/
_writer.print(">\n");
_writer.print("<"+attribut_enum+">\n");
Vector v=_decl.getValueListe();
if (v!=null){
for (int i=0;i<v.size();i++)
{
_writer.print("<"+value_liste+" "+attribut_value+"=\""+(String)v.get(i)+"\" />\n");
}}
_writer.print("</"+attribut_enum+">\n");
_writer.print("</"+attribut_balise_def+">\n");
}
public static void WriteStyle(PrintWriter _writer,SimpleAttributeSet attr)
{
_writer.print("<"+style_def+" "+font+"=\""+StyleConstants.getFontFamily(attr)+"\" "+fontsize+"=\""+StyleConstants.getFontSize(attr)+"\"");
_writer.print(" "+backcolor_red+"=\""+StyleConstants.getBackground(attr).getRed()+"\" "+frontcolor_red+"=\""+StyleConstants.getForeground(attr).getRed()+"\"");
_writer.print(" "+backcolor_green+"=\""+StyleConstants.getBackground(attr).getGreen()+"\" "+frontcolor_green+"=\""+StyleConstants.getForeground(attr).getGreen()+"\"");
_writer.print(" "+backcolor_blue+"=\""+StyleConstants.getBackground(attr).getBlue()+"\" "+frontcolor_blue+"=\""+StyleConstants.getForeground(attr).getBlue()+"\"");
_writer.print(" "+underline+"=\""+StyleConstants.isUnderline(attr)+"\" "+bold+"=\""+StyleConstants.isBold(attr)+"\" "+strike+"=\""+StyleConstants.isStrikeThrough(attr)+"\" ");
_writer.print(" "+italic+"=\""+StyleConstants.isItalic(attr)+"\" />\n"); 
/** TODO CONTINUER **/
}
public static void WriteBalise(PrintWriter _writer ,Balise b)
{
_writer.print("<"+balise_def+" "+balise_name+"=\""+b.getName()+"\" "+empty+"=\""+b.IsEmptyBalise()+"\" "+order+"=\""+b.getOrder()+"\">\n");
WriteStyle(_writer,b.getAttribut());
Vector v=b.getListeAttribut();
System.out.println("WriteBALISe"+b+" "+v.size());
for (int i=0;i<v.size();i++)
{
WriteAttributDecl(_writer,(AttributDecl)v.get(i));
}
_writer.print("</"+balise_def+">\n");
}
public static void WriteListeBalise(PrintWriter _writer,ListeBalise b)
{
_writer.print("<"+liste_balise_def+">\n");
for (int i=0;i<b.size();i++)
{
WriteBalise(_writer,(Balise)b.get(i));
}
_writer.print("</"+liste_balise_def+">\n");
}
public static void WriteDocument(PrintWriter _writer,ListeTag _tag,ListeBalise b,String texte,String dtdfilename)
{
_writer.print("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n" );
_writer.print("<XmlJavaDocument>\n");
_writer.print("<dtdfilename name=\""+dtdfilename+"\" />");
WriteListeBalise(_writer,b);
WriteListeTag(_writer,_tag);
_writer.print("<"+_text+">");
_writer.println(texte);
_writer.print("</"+_text+">\n");
_writer.print("</XmlJavaDocument>\n");
_writer.flush();

}
}